# ConjugateGradients.jl

`ConjugateGradients.jl` is a flexible, non-allocating Julia implementation of the conjugate gradient and biconjugate gradient stabilized methods.

## Requirements

* Julia 1.2 and up

## Installation

```julia
julia> Pkg.add("https://github.com/mcovalt/ConjugateGradients.jl.git")
```

## Why use ConjugateGradients.jl?

There are a few great iterative solver packages available for Julia: [IterativeSolvers.jl](https://github.com/JuliaMath/IterativeSolvers.jl), [KrylovMethods.jl](https://github.com/lruthotto/KrylovMethods.jl), and [Krylov.jl](https://github.com/JuliaSmoothOptimizers/Krylov.jl). These are all very well rounded and complete packages.

This package, `ConjugateGradients.jl`, is built around reducing allocations as much as possible for a particular type of problem. As far as I know, if your program will be using an iterative solver *within* another iterative process, this module will result in less allocations compared to the previously mentioned packages. Hint: take a look at [ILUZero.jl](https://github.com/mcovalt/ILUZero.jl) if this type of solver would be beneficial to your project. Combined, these packages can help reduce allocations in those hot paths.

Also, in other iterative solvers, calls to BLAS functions are preferred for obvious reasons. This package uses Julia's multiple dispatch functionality to decide whether to use BLAS or native Julia code to make calculations based on the type associated with the arrays. This gives greater flexibility with types not represented by floating point numbers.

## How to use

```julia
julia> using ConjugateGradients
```

For the conjugate gradient method to solve for `x` in `Ax=b`:

```julia
x, exit_code, num_iters = cg(A, b; kwargs...)
```
```julia
exit_code, num_iters = cg!(A, b, x; kwargs...)
```

For the biconjugate gradient stabilized method:

```julia
x, exit_code, num_iters = bicgstab(A, b; kwargs...)
```
```julia
exit_code, num_iters = bicgstab!(A, b, x; kwargs...)
```

Where `A` must be able to be applied as a function such that `A(b, x)` and the `kwargs` are:
* `tol = 1e-6`: The tolerance of the minimum residual before convergence is accepted.
* `maxIter = 100`: The maximum number of iterations to perform.
* `tolRho = 1e-40`: [`bicgstab` only] The tolerance of `dot(current residual, initial residual)`.
* `precon = nothing`: The preconditioner. The preconditioner must act as an in-place function of the form `f(out, in)`.
* `data = nothing`: The preallocation of the arrays used for solving the system.

### Preallocating

The `data` keyword points to an object containing the preallocated vectors necessary for the functions. If nothing is provided, these vectors will be allocated at each call. The data objects can be created like so:

```julia
CGD = CGData(n, T)
```

```julia
BCGD = BiCGStabData(n, T)
```

Here, `n` is the dimension of the problem and `T` is the type of the elements in the problem (e.g. `Float64`).

### Deciphering the exit code

The `exit_code` can be read with the following function:

```julia
exit_string = reader(exit_code)
```

### A tip for `A` and the preconditioner

The operator `A` and the preconditioner must be expressed as functions. If `A` is a matrix, one can do:

```julia
x, exit_code, num_iters = cg((x,y) -> mul!(x,A,y), b; kwargs...)
```

Another useful representation of `A` is a custom struct. For example, let's consider `(B*C + D)x = b`. Instead of wasting time to build `B*C + D`, we can create a non-allocating version of it.


```julia
struct MyA
    B::SparseMatrixCSC{Float64,Int64}
    C::SparseMatrixCSC{Float64,Int64}
    D::SparseMatrixCSC{Float64,Int64}
    cacheVec::Vector{Float64}
end

function (t::MyA)(out::Vector{Float64}, x::Vector{Float64})
    mul!(t.cacheVec, t.C, x)
    mul!(out, t.B, t.cacheVec)
    mul!(t.cacheVec, t.D, x)
    out .+= t.cacheVec
end

A = MyA(B, C, D, zeros(n))
```

# Data container
struct BiCGStabData{T}
    v::Vector{T}
    t::Vector{T}
    p::Vector{T}
    phat::Vector{T}
    s::Vector{T}
    shat::Vector{T}
    r::Vector{T}
    rtld::Vector{T}
    BiCGStabData(n::Int, T::Type) = new{T}(
        zeros(T, n), zeros(T, n),
        zeros(T, n), zeros(T, n),
        zeros(T, n), zeros(T, n),
        zeros(T, n), zeros(T, n))
end

# Main solver
function bicgstab!(A, b::Vector{T}, x::Vector{T};
                   tol::Float64=1e-6, maxIter::Int64=100,
                   tolRho::Float64=1e-40, precon=copy!,
                   data=BiCGStabData(length(b), T)) where {T<:Real}
    bnrm2 = genblas_nrm2(b)
    if bnrm2 == 0.0
        x .= 0.0
        return 1, 0
    end
    A(data.r, x)
    genblas_scal!(-one(T), data.r)
    genblas_axpy!(one(T), b, data.r)
    residual = genblas_nrm2(data.r)/bnrm2
    if residual == 0.0
        return 2, 0
    end
    alpha = 1.0
    omega = 1.0
    data.rtld .= data.r
    rho1 = 0.0
    data.p .= data.r
    for iter = 1:maxIter
        rho = genblas_dot(data.rtld, data.r)
        if abs(rho) <= tolRho
            return -11, iter
        end
        if iter > 1
            beta  = (rho/rho1)*(alpha/omega)
            # p = r + beta*(p - omega*v)
            genblas_scal!(beta, data.p)
            genblas_axpy!(-(beta*omega), data.v, data.p)
            genblas_axpy!(one(T), data.r, data.p)
        end
        precon(data.phat, data.p)
        A(data.v, data.phat)
        alpha = rho/genblas_dot(data.rtld, data.v)
        # s = r - alpha*v
        data.s .= data.r
        genblas_axpy!(-alpha, data.v, data.s)
        # x = x + alpha*phat
        genblas_axpy!(alpha, data.phat, x)
        residual = genblas_nrm2(data.s)/bnrm2
        if residual <= tol
            return 31, iter
        end
        precon(data.shat, data.s)
        A(data.t, data.shat)
        omega = genblas_dot(data.t, data.s)/genblas_dot(data.t, data.t)
        # x = x + omega*shat
        genblas_axpy!(omega, data.shat, x)
        # r = s .- omega.*t
        data.r .= data.s
        genblas_axpy!(-omega, data.t, data.r)
        residual = genblas_nrm2(data.r)/bnrm2
        if residual <= tol
            return 32, iter
        end
        if abs(omega) < 1e-16
            return -12, iter
        end
        rho1 = rho
    end
    return -2, maxIter
end

# API
function bicgstab(A, b::Vector{T};
                  tol::Float64=1e-6, maxIter::Int64=100,
                  tolRho::Float64=1e-40, precon=copy!,
                  data=BiCGStabData(length(b), T)) where {T<:Real}
    x = zeros(eltype(b), length(b))
    exit_code, num_iters = bicgstab!(A, b, x, tol=tol, maxIter=maxIter, tolRho=tolRho, precon=precon, data=data)
    return x, exit_code, num_iters
end

export BiCGStabData, bicgstab!, bicgstab

import LinearAlgebra: BLAS, BlasFloat, norm

genblas_dot(x::Vector{T}, y::Vector{T}) where {T<:BlasFloat} = BLAS.dot(x, y)
genblas_dot(x, y) = dot(x,y)
genblas_scal!(a::T, x::Vector{T}) where {T<:BlasFloat} = BLAS.scal!(length(x), a, x, 1)
genblas_scal!(a, x) = x .*= a
genblas_axpy!(a::T, x::Vector{T}, y::Vector{T}) where {T<:BlasFloat} = BLAS.axpy!(a, x, y)
genblas_axpy!(a, x, y) = y .+= a.*x
genblas_nrm2(x::Vector{T}) where {T<:BlasFloat} = BLAS.nrm2(length(x), x, 1)
genblas_nrm2(x) = norm(x)

using ConjugateGradients
using LinearAlgebra
using SparseArrays
using Test

function test_cg(n=100)
    tA = sprandn(n, n, 0.1) + spdiagm(0=>fill(10.0, n))
    A = tA'*tA
    b = rand(n)
    true_x = A\b
    x, exit_code, num_iters = cg((x,y) -> mul!(x, A, y), b)
    norm(true_x - x) < 1e-6
end

function test_bicgstab(n=100)
    A = sprandn(n, n, 0.1) + spdiagm(0=>fill(10.0, n))
    b = rand(n)
    true_x = A\b
    x, exit_code, num_iters = bicgstab((x,y) -> mul!(x, A, y), b)
    norm(true_x - x) < 1e-6
end

@testset "ConjugateGradients" begin
    @test test_cg()
    @test test_bicgstab()
end

# Displays exit code information
function reader(exit_code)
    if exit_code == 1
        return "CONVERGED: Provided vector b has zero norm. Returned x as vector of zeros."
    elseif exit_code == 2
        return "CONVERGED: Initial guess of vector x results in sufficient residual."
    elseif exit_code == 30
        return "CONVERGED: Sufficient residual achieved."
    elseif exit_code == 31
        return "CONVERGED: Sufficient residual achieved at first step."
    elseif exit_code == 32
        return "CONVERGED: Sufficient residual achieved at second step."
    elseif exit_code == -11
        return "DID NOT CONVERGE: Rho fell below tolerance."
    elseif exit_code == -12
        return "DID NOT CONVERGE: Omega fell below tolerance."
    elseif exit_code == -13
        return "DID NOT CONVERGE: Zero or infinity alpha."
    elseif exit_code == -2
        return "DID NOT CONVERGE: Maximum iterations reached before convergence."
    else
        return "Invalid error code."
    end
end

export reader

# Data container
struct CGData{T<:Real}
    r::Vector{T}
    z::Vector{T}
    p::Vector{T}
    Ap::Vector{T}
    CGData(n::Int, T::Type) = new{T}(
        zeros(T, n), zeros(T, n),
        zeros(T, n), zeros(T, n))
end

# Solves for x
function cg!(A, b::Vector{T}, x::Vector{T};
             tol::Float64=1e-6, maxIter::Int64=100,
             precon=copy!,
             data=CGData(length(b), T)) where {T<:Real}
    if genblas_nrm2(b) == 0.0
        x .= 0.0
        return 1, 0
    end
    A(data.r, x)
    genblas_scal!(-one(T), data.r)
    genblas_axpy!(one(T), b, data.r)
    residual_0 = genblas_nrm2(data.r)
    if residual_0 <= tol
        return 2, 0
    end
    precon(data.z, data.r)
    data.p .= data.z
    for iter = 1:maxIter
        A(data.Ap, data.p)
        gamma = genblas_dot(data.r, data.z)
        alpha = gamma/genblas_dot(data.p, data.Ap)
        if alpha == Inf || alpha < 0
            return -13, iter
        end
        # x += alpha*p
        genblas_axpy!(alpha, data.p, x)
        # r -= alpha*Ap
        genblas_axpy!(-alpha, data.Ap, data.r)
        residual = genblas_nrm2(data.r)/residual_0
        if residual <= tol
            return 30, iter
        end
        precon(data.z, data.r)
        beta = genblas_dot(data.z, data.r)/gamma
        # p = z + beta*p
        genblas_scal!(beta, data.p)
        genblas_axpy!(1.0, data.z, data.p)
    end
    return -2, maxIter
end

# API
function cg(A, b::Vector{T};
            tol::Float64=1e-6, maxIter::Int64=100,
            precon=copy!,
            data=CGData(length(b), T)) where {T<:Real}
    x = zeros(eltype(b), length(b))
    exit_code, num_iters = cg!(A, b, x, tol=tol, maxIter=maxIter, precon=precon, data=data)
    return x, exit_code, num_iters
end

export CGData, cg!, cg
